﻿
Перем Запись;

Процедура ВывестиКлассМетаданных(Знач Класс)
	
	ИмяКласса = Класс.name(1, Истина);
	
	Сообщить(ИмяКласса);
	
	Запись.ЗаписатьНачалоЭлемента("class");
	Запись.ЗаписатьАтрибут("id", Класс.id);
	Запись.ЗаписатьАтрибут("name", ИмяКласса);
	Запись.ЗаписатьАтрибут("presentation", Класс.presentation(Истина));
	
	ВывестиСвойстваКласса(Класс);
	
	// подсистемы рекурсивно выводить нельзя, т.к. они вложены друг-в-друга и рекурсия зависает.
	Если Класс.id <> "{37F2FA9A-B276-11D4-9435-004095E12FC7}" Тогда // подсистемы
		ВывестиДочерниеКлассы(Класс);
	КонецЕсли;
	
	Запись.ЗаписатьКонецЭлемента();
	ОсвободитьОбъект(Класс);
	
КонецПроцедуры

Процедура ВывестиСвойстваКласса(Знач Класс)
	
	Запись.ЗаписатьНачалоЭлемента("properties");
	
	КоличествоСвойств = Класс.propertiesCount;
	
	Для Сч = 0 По КоличествоСвойств-1 Цикл
		
		Свойство = Класс.propertyAt(Сч);
		Запись.ЗаписатьНачалоЭлемента("property");
		Запись.ЗаписатьАтрибут("id", Свойство.id);
		Запись.ЗаписатьАтрибут("name", Свойство.name(1));
		Запись.ЗаписатьАтрибут("category", Свойство.category);
		Запись.ЗаписатьКонецЭлемента();
		ОсвободитьОбъект(Свойство);
		
	КонецЦикла;
	
	Запись.ЗаписатьКонецЭлемента();
	
	
КонецПроцедуры

Процедура ВывестиДочерниеКлассы(Знач Класс)
	
	Запись.ЗаписатьНачалоЭлемента("childClasses");
	
	Количество = Класс.childsClassesCount;
	
	Для Сч = 0 По Количество-1 Цикл
		
		ДочернийКласс = Класс.childClassAt(Сч);
		ВывестиКлассМетаданных(ДочернийКласс);
		
	КонецЦикла;
	
	Запись.ЗаписатьКонецЭлемента();
	
КонецПроцедуры

Процедура Макрос_СохранитьСтруктуруМетаданных() Экспорт
	
	Диалог = Новый ДиалогВыбораФайла(globalContext("{2482FC4E-012A-4E97-88A1-77DE6EC8DEA2}").РежимДиалогаВыбораФайла.Сохранение);
	Диалог.Фильтр = "Файлы XML|*.xml";
	Если Диалог.Выбрать() Тогда
		Запись = Новый ЗаписьXML();
		Запись.ОткрытьФайл(Диалог.ПолноеИмяФайла);
		Попытка
			ВывестиКлассМетаданных(metadata.current.rootObject.mdclass);
		Исключение
			Сообщить(ИнформацияОбОшибке().Описание);
		КонецПопытки;
		Запись.Закрыть();
	КонецЕсли;
	
КонецПроцедуры
